package xml.teste;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.DomDriver;

/**
 * Classe que contm os mtodos para a criao e leitura do arquivo XML usando a
 * lib XStream
 * 
 * @author Daniel Paulo de Assis
 * 
 */
public class FileXML {

	/**
	 * Mtodo que cria um arquivo XML com dados do objeto tipo Pessoa
	 * 
	 * @param <code>Pessoa</code> pessoa
	 * @throws IOException
	 */
	public void gerarXML(Pessoa pessoa) throws IOException {

		/** Instancia simples da classe XSTream **/
		XStream xStream = new XStream();

		/** Criando apelido para a classe que gerara o xml (opcional) **/
		xStream.alias("Pessoa", Pessoa.class);

		/** Criando o arquivo em disco **/
		FileWriter file = new FileWriter("C:\\pessoa.xml", true);
		file.write(xStream.toXML(pessoa));
		file.close();

		/** Imprimindo no console o resultado **/
		System.out.println(xStream.toXML(pessoa));

	}

	/**
	 * Mtodo que faz a leitura do arquivo XML utilizando a lib XStream
	 * 
	 * @throws IOException
	 */
	public void lerXML() throws IOException {

		/**
		 * Instanciando objeto da Classe XStream(DomDriver  utilizado para o
		 * fazer o parse sem a necessidade de add novas libs
		 **/
		XStream xStream = new XStream(new DomDriver());

		/** Lendo o arquivo em disco **/
		File file = new File("C:\\pessoa.xml");
		FileInputStream input = new FileInputStream(file);

		xStream.alias("Pessoa", Pessoa.class);

		/** Fazendo o cast para o tipo de objeto Pessoa **/
		Pessoa xml = (Pessoa) xStream.fromXML(input);

		/** Imprimindo o resultado no console **/
		System.out.println("Nome  :" + xml.getNome());
		System.out.println("Idade :" + xml.getIdade());

	}
}
